package db

import (
	"applet/app/db/model"
	"applet/app/utils"
	"xorm.io/xorm"
)

func GetCoinAmountDate(sess *xorm.Session, coinId, date string) *model.CoinAmountDateTotal {
	var data model.CoinAmountDateTotal
	get, _ := sess.Where("coin_id=? and date=?", coinId, date).Get(&data)
	if get == false {
		data = model.CoinAmountDateTotal{
			Date:   utils.StrToInt(date),
			Amount: "0",
			CoinId: utils.StrToInt(coinId),
		}
		one, err := sess.InsertOne(&data)
		if one == 0 || err != nil {
			return nil
		}
	}
	return &data

}
func GetCoinAmountDateForUse(sess *xorm.Session, coinId, date, uid string) *model.CoinAmountUserTotal {
	var data model.CoinAmountUserTotal
	get, _ := sess.Where("coin_id=? and date=? and uid=?", coinId, date, uid).Get(&data)
	if get == false {
		data = model.CoinAmountUserTotal{
			Date:   utils.StrToInt(date),
			Uid:    utils.StrToInt(uid),
			Amount: "0",
			CoinId: utils.StrToInt(coinId),
		}
		one, err := sess.InsertOne(&data)
		if one == 0 || err != nil {
			return nil
		}
	}
	return &data

}
