package consume

import (
	"applet/app/db"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
	"strings"
)

func CanalOneOrengeUserVirtualCoinFlowConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>CanalUserVirtualCoinFlowConsume>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			//fmt.Println(string(res.Body))
			fmt.Println(">>>>>>>>>>>>>>>>CanalUserVirtualCoinFlowConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			err = handleCanalOneOrengeUserVirtualCoinFlow(res.Body)
			if err != nil {
				fmt.Println("handleCanalUserVirtualCoinFlow_ERR:::::", err.Error())
			}
			//_ = res.Reject(false)
			err = res.Ack(true)
			fmt.Println("err ::: ", err)
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleCanalOneOrengeUserVirtualCoinFlow(msg []byte) error {
	//1、解析canal采集至mq中queue的数据结构体
	var canalMsg *md.CanalUserVirtualCoinFlowOrderMessage[md.CanalUserVirtualCoinFlowOrder]
	err := json.Unmarshal(msg, &canalMsg)
	if err != nil {
		return err
	}

	masterId := strings.Split(canalMsg.Database, "_")[1]
	if masterId != "15763466" {
		return nil
	}
	engine := db.DBs[masterId]
	if canalMsg.Type == md.CanalMsgInsertSqlType {
		if canalMsg.Data[0].TransferType == "9" || canalMsg.Data[0].Direction != "1" || utils.StrToFloat64(canalMsg.Data[0].Amout) <= 0 {
			//转赠不记录
			return nil
		}
		sess := engine.NewSession()
		defer sess.Close()
		sess.Begin()
		date := utils.TimeParseStd(canalMsg.Data[0].CreateTime).Format("20060102")
		amountDate := db.GetCoinAmountDate(sess, canalMsg.Data[0].CoinId, date)
		if amountDate == nil {
			sess.Rollback()
			return errors.New("失败")
		}
		amountDate.Amount = utils.Float64ToStrByPrec(utils.StrToFloat64(canalMsg.Data[0].Amout)+utils.StrToFloat64(amountDate.Amount), 8)
		update, err := sess.Where("id=?", amountDate.Id).Cols("amount").Update(amountDate)
		if update == 0 || err != nil {
			sess.Rollback()
			return errors.New("失败")
		}

		amountUser := db.GetCoinAmountDateForUse(sess, canalMsg.Data[0].CoinId, date, canalMsg.Data[0].Uid)
		if amountUser == nil {
			sess.Rollback()
			return errors.New("失败")
		}
		amountUser.Amount = utils.Float64ToStrByPrec(utils.StrToFloat64(canalMsg.Data[0].Amout)+utils.StrToFloat64(amountUser.Amount), 8)
		update, err = sess.Where("id=?", amountUser.Id).Cols("amount").Update(amountUser)
		if update == 0 || err != nil {
			sess.Rollback()
			return errors.New("失败")
		}
		sess.Commit()
	}

	return nil
}
